# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "context4xi.py">
#<abstract4xi abstract = "Context management"/>
#<refer4xi reference = "Context"/>
#<verify4xi verification = "10" target = "context4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Context4Xi',
            'create2context4xi',
            'get2context4xi',
            'release2context4xi',
            'retain2context4xi',
            'set2context4xi'
          ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

from apu2context4xi import APU2Context4Xi                                                                           
from bpu2context4xi import BPU2Context4Xi 
from cpu2context4xi import CPU2Context4Xi 
from dpu2context4xi import DPU2Context4Xi 
from epu2context4xi import EPU2Context4Xi 
from fpu2context4xi import FPU2Context4Xi 
from gpu2context4xi import GPU2Context4Xi 
from hpu2context4xi import HPU2Context4Xi 
from ipu2context4xi import IPU2Context4Xi 
from jpu2context4xi import JPU2Context4Xi 
from kpu2context4xi import KPU2Context4Xi 
from lpu2context4xi import LPU2Context4Xi 
from mpu2context4xi import MPU2Context4Xi 
from npu2context4xi import NPU2Context4Xi 
from opu2context4xi import OPU2Context4Xi 
from ppu2context4xi import PPU2Context4Xi 
from qpu2context4xi import QPU2Context4Xi 
from rpu2context4xi import RPU2Context4Xi 
from spu2context4xi import SPU2Context4Xi 
from tpu2context4xi import TPU2Context4Xi 
from upu2context4xi import UPU2Context4Xi 
from vpu2context4xi import VPU2Context4Xi 
from xpu2context4xi import XPU2Context4Xi 
from wpu2context4xi import WPU2Context4Xi 
from ypu2context4xi import YPU2Context4Xi 
from zpu2context4xi import ZPU2Context4Xi 

from apu2context4xi import create2context4apu 
from bpu2context4xi import create2context4bpu
from cpu2context4xi import create2context4cpu
from dpu2context4xi import create2context4dpu
from epu2context4xi import create2context4epu
from fpu2context4xi import create2context4fpu
from gpu2context4xi import create2context4gpu
from hpu2context4xi import create2context4hpu
from ipu2context4xi import create2context4ipu
from jpu2context4xi import create2context4jpu
from kpu2context4xi import create2context4kpu
from lpu2context4xi import create2context4lpu
from mpu2context4xi import create2context4mpu
from npu2context4xi import create2context4npu
from opu2context4xi import create2context4opu
from ppu2context4xi import create2context4ppu
from qpu2context4xi import create2context4qpu
from rpu2context4xi import create2context4rpu
from spu2context4xi import create2context4spu
from tpu2context4xi import create2context4tpu
from upu2context4xi import create2context4upu
from vpu2context4xi import create2context4vpu
from xpu2context4xi import create2context4xpu
from wpu2context4xi import create2context4wpu
from ypu2context4xi import create2context4ypu
from zpu2context4xi import create2context4zpu


from apu2context4xi import get2context4apu
from bpu2context4xi import get2context4bpu
from cpu2context4xi import get2context4cpu
from dpu2context4xi import get2context4dpu
from epu2context4xi import get2context4epu
from fpu2context4xi import get2context4fpu
from gpu2context4xi import get2context4gpu
from hpu2context4xi import get2context4hpu
from ipu2context4xi import get2context4ipu
from jpu2context4xi import get2context4jpu
from kpu2context4xi import get2context4kpu
from lpu2context4xi import get2context4lpu
from mpu2context4xi import get2context4mpu
from npu2context4xi import get2context4npu
from opu2context4xi import get2context4opu
from ppu2context4xi import get2context4ppu
from qpu2context4xi import get2context4qpu
from rpu2context4xi import get2context4rpu
from spu2context4xi import get2context4spu
from tpu2context4xi import get2context4tpu
from upu2context4xi import get2context4upu
from vpu2context4xi import get2context4vpu
from xpu2context4xi import get2context4xpu
from wpu2context4xi import get2context4wpu
from ypu2context4xi import get2context4ypu
from zpu2context4xi import get2context4zpu


from apu2context4xi import release2context4apu
from bpu2context4xi import release2context4bpu
from cpu2context4xi import release2context4cpu
from dpu2context4xi import release2context4dpu
from epu2context4xi import release2context4epu
from fpu2context4xi import release2context4fpu
from gpu2context4xi import release2context4gpu
from hpu2context4xi import release2context4hpu
from ipu2context4xi import release2context4ipu
from jpu2context4xi import release2context4jpu
from kpu2context4xi import release2context4kpu
from lpu2context4xi import release2context4lpu
from mpu2context4xi import release2context4mpu
from npu2context4xi import release2context4npu
from opu2context4xi import release2context4opu
from ppu2context4xi import release2context4ppu
from qpu2context4xi import release2context4qpu
from rpu2context4xi import release2context4rpu
from spu2context4xi import release2context4spu
from tpu2context4xi import release2context4tpu
from upu2context4xi import release2context4upu
from vpu2context4xi import release2context4vpu
from xpu2context4xi import release2context4xpu
from wpu2context4xi import release2context4wpu
from ypu2context4xi import release2context4ypu
from zpu2context4xi import release2context4zpu

from apu2context4xi import retain2context4apu
from bpu2context4xi import retain2context4bpu
from cpu2context4xi import retain2context4cpu
from dpu2context4xi import retain2context4dpu
from epu2context4xi import retain2context4epu
from fpu2context4xi import retain2context4fpu
from gpu2context4xi import retain2context4gpu
from hpu2context4xi import retain2context4hpu
from ipu2context4xi import retain2context4ipu
from jpu2context4xi import retain2context4jpu
from kpu2context4xi import retain2context4kpu
from lpu2context4xi import retain2context4lpu
from mpu2context4xi import retain2context4mpu
from npu2context4xi import retain2context4npu
from opu2context4xi import retain2context4opu
from ppu2context4xi import retain2context4ppu
from qpu2context4xi import retain2context4qpu
from rpu2context4xi import retain2context4rpu
from spu2context4xi import retain2context4spu
from tpu2context4xi import retain2context4tpu
from upu2context4xi import retain2context4upu
from vpu2context4xi import retain2context4vpu
from xpu2context4xi import retain2context4xpu
from wpu2context4xi import retain2context4wpu
from ypu2context4xi import retain2context4ypu
from zpu2context4xi import retain2context4zpu


from apu2context4xi import set2context4apu
from bpu2context4xi import set2context4bpu
from cpu2context4xi import set2context4cpu
from dpu2context4xi import set2context4dpu
from epu2context4xi import set2context4epu
from fpu2context4xi import set2context4fpu
from gpu2context4xi import set2context4gpu
from hpu2context4xi import set2context4hpu
from ipu2context4xi import set2context4ipu
from jpu2context4xi import set2context4jpu
from kpu2context4xi import set2context4kpu
from lpu2context4xi import set2context4lpu
from mpu2context4xi import set2context4mpu
from npu2context4xi import set2context4npu
from opu2context4xi import set2context4opu
from ppu2context4xi import set2context4ppu
from qpu2context4xi import set2context4qpu
from rpu2context4xi import set2context4rpu
from spu2context4xi import set2context4spu
from tpu2context4xi import set2context4tpu
from upu2context4xi import set2context4upu
from vpu2context4xi import set2context4vpu
from xpu2context4xi import set2context4xpu
from wpu2context4xi import set2context4wpu
from ypu2context4xi import set2context4ypu
from zpu2context4xi import set2context4zpu


from apu2device4xi import APU4Xi                                                                                   
from bpu2device4xi import BPU4Xi  
from cpu2device4xi import CPU4Xi  
from dpu2device4xi import DPU4Xi  
from epu2device4xi import EPU4Xi  
from fpu2device4xi import FPU4Xi  
from gpu2device4xi import GPU4Xi  
from hpu2device4xi import HPU4Xi  
from ipu2device4xi import IPU4Xi  
from jpu2device4xi import JPU4Xi  
from kpu2device4xi import KPU4Xi  
from lpu2device4xi import LPU4Xi  
from mpu2device4xi import MPU4Xi  
from npu2device4xi import NPU4Xi  
from opu2device4xi import OPU4Xi  
from ppu2device4xi import PPU4Xi  
from qpu2device4xi import QPU4Xi  
from rpu2device4xi import RPU4Xi  
from spu2device4xi import SPU4Xi  
from tpu2device4xi import TPU4Xi  
from upu2device4xi import UPU4Xi  
from vpu2device4xi import VPU4Xi  
from xpu2device4xi import XPU4Xi  
from wpu2device4xi import WPU4Xi  
from ypu2device4xi import YPU4Xi  
from zpu2device4xi import ZPU4Xi  

from apu2device4xi import init2apu4xi 
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi
from cpu2device4xi import set2cpu4xi
from dpu2device4xi import set2dpu4xi
from epu2device4xi import set2epu4xi
from fpu2device4xi import set2fpu4xi
from gpu2device4xi import set2gpu4xi
from hpu2device4xi import set2hpu4xi
from ipu2device4xi import set2ipu4xi
from jpu2device4xi import set2jpu4xi
from kpu2device4xi import set2kpu4xi
from lpu2device4xi import set2lpu4xi
from mpu2device4xi import set2mpu4xi
from npu2device4xi import set2npu4xi
from opu2device4xi import set2opu4xi
from ppu2device4xi import set2ppu4xi
from qpu2device4xi import set2qpu4xi
from rpu2device4xi import set2rpu4xi
from spu2device4xi import set2spu4xi
from tpu2device4xi import set2tpu4xi
from upu2device4xi import set2upu4xi
from vpu2device4xi import set2vpu4xi
from xpu2device4xi import set2xpu4xi
from wpu2device4xi import set2wpu4xi
from ypu2device4xi import set2ypu4xi
from zpu2device4xi import set2zpu4xi

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi
from cpu2device4xi import get2cpu4xi
from dpu2device4xi import get2dpu4xi
from epu2device4xi import get2epu4xi
from fpu2device4xi import get2fpu4xi
from gpu2device4xi import get2gpu4xi
from hpu2device4xi import get2hpu4xi
from ipu2device4xi import get2ipu4xi
from jpu2device4xi import get2jpu4xi
from kpu2device4xi import get2kpu4xi
from lpu2device4xi import get2lpu4xi
from mpu2device4xi import get2mpu4xi
from npu2device4xi import get2npu4xi
from opu2device4xi import get2opu4xi
from ppu2device4xi import get2ppu4xi
from qpu2device4xi import get2qpu4xi
from rpu2device4xi import get2rpu4xi
from spu2device4xi import get2spu4xi
from tpu2device4xi import get2tpu4xi
from upu2device4xi import get2upu4xi
from vpu2device4xi import get2vpu4xi
from xpu2device4xi import get2xpu4xi
from wpu2device4xi import get2wpu4xi
from ypu2device4xi import get2ypu4xi
from zpu2device4xi import get2zpu4xi



from platforminfo4xi import PlatformInfo4Xi                                                                         # PLATFORM4XI
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global context4xi
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2context4xi" usage = " 
#
# print('=' *33)          
# print('(Step 2A/33) OF CONTEXT4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())   
# print('=' *33)        
# try:
#     context2xi = create2context4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
#     print('(Step 2B/33) OF CONTEXT4XI5TEST - CREATED CONTEXT4XI TO: ', context2xi)                                  
#     # 
# except:
#     print('(Step 2Z/33) OF CONTEXT4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def create2context4xi(task4create2context=None):

    '''
    initializes context4xi
    '''
    global context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2context4xi"
    method2print = "create2context4xi"

    message2print = "{(Step 1A/33) started" + "; create2context4xi-started: " + str(create2context4xi)  + "; time: " + time4xi() + "}"   
    print4xi(class2print, method2print, message2print)
    # <function create2context4xi at 0x0000000003612248>
  
             
    message2print = "{(Step 1B/33) passed" + "; task4create2context-to-create2context4xi: " + str(task4create2context) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # None  


    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4create2context is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - CONTEXT4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        if context4xi is None:                                                                                       
            context4xi = {} 
            code2ack  = code2ack + '1D-'
    
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4create2context-try-by-create2context4xi: " + str(task4create2context)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None
    
 

    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES 
            # ----------------------------------------------------------------------------------------- 
        
            context4xi = {} 
            context4xi['APU'] = create2context4apu()                                                                        
            context4xi['BPU'] = create2context4bpu()  
            context4xi['CPU'] = create2context4cpu()  
            context4xi['DPU'] = create2context4dpu()  
            context4xi['EPU'] = create2context4epu()  
            context4xi['FPU'] = create2context4fpu()  
            context4xi['GPU'] = create2context4gpu()  
            context4xi['HPU'] = create2context4hpu()  
            context4xi['IPU'] = create2context4ipu()  
            context4xi['JPU'] = create2context4jpu()  
            context4xi['KPU'] = create2context4kpu()  
            context4xi['LPU'] = create2context4lpu()  
            context4xi['MPU'] = create2context4mpu()  
            context4xi['NPU'] = create2context4npu()  
            context4xi['OPU'] = create2context4opu()  
            context4xi['PPU'] = create2context4ppu()  
            context4xi['QPU'] = create2context4qpu()  
            context4xi['RPU'] = create2context4rpu()  
            context4xi['SPU'] = create2context4spu()  
            context4xi['TPU'] = create2context4tpu()  
            context4xi['UPU'] = create2context4upu()  
            context4xi['VPU'] = create2context4vpu()  
            context4xi['XPU'] = create2context4xpu()  
            context4xi['WPU'] = create2context4wpu()  
            context4xi['YPU'] = create2context4ypu()  
            context4xi['ZPU'] = create2context4zpu()  
                                          
            message2print = "{(Step 3A/33) initialized" + "; context4xi-initialized-by-create2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # {'VPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'DPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'RPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4rpu', 'METHOD': 'create2context4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'SPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4spu', 'METHOD': 'create2context4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'APU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4apu', 'METHOD': 'create2context4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'PPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4ppu', 'METHOD': 'create2context4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'GPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4gpu', 'METHOD': 'create2context4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
            #  'CPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}

            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; context4xi-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    

        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            context4xi['APU'] = create2context4apu(task4create2context['APU'])
            
            message2print = "{(Step A1/33) initialized" + "; apu-initialized-by-create2context4xi to: " + str(context4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'},
            #  'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}

            code2ack  = code2ack + 'A1-'
        except: 
            message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            context4xi['BPU'] = create2context4bpu(task4create2context['BPU'])
            
            message2print = "{(Step B1/33) initialized" + "; bpu-initialized-by-create2context4xi to: " + str(context4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'B1-'
        except: 
            message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            context4xi['CPU'] = create2context4cpu(task4create2context['CPU'])
            
            message2print = "{(Step C1/33) initialized" + "; cpu-initialized-by-create2context4xi to: " + str(context4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'C1-'
        except: 
            message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            context4xi['DPU'] = create2context4dpu(task4create2context['DPU'])
            
            message2print = "{(Step D1/33) initialized" + "; dpu-initialized-by-create2context4xi to: " + str(context4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'D1-'
        except: 
            message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            context4xi['EPU'] = create2context4epu(task4create2context['EPU'])
            
            message2print = "{(Step E1/33) initialized" + "; epu-initialized-by-create2context4xi to: " + str(context4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'E1-'
        except: 
            message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            context4xi['FPU'] = create2context4fpu(task4create2context['FPU'])
            
            message2print = "{(Step F1/33) initialized" + "; fpu-initialized-by-create2context4xi to: " + str(context4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'F1-'
        except: 
            message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            context4xi['GPU'] = create2context4gpu(task4create2context['GPU'])
            
            message2print = "{(Step G1/33) initialized" + "; gpu-initialized-by-create2context4xi to: " + str(context4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'G1-'
        except: 
            message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            context4xi['HPU'] = create2context4hpu(task4create2context['HPU'])
            
            message2print = "{(Step H1/33) initialized" + "; hpu-initialized-by-create2context4xi to: " + str(context4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'H1-'
        except: 
            message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            context4xi['IPU'] = create2context4ipu(task4create2context['IPU'])
            
            message2print = "{(Step I1/33) initialized" + "; ipu-initialized-by-create2context4xi to: " + str(context4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'I1-'
        except: 
            message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            context4xi['JPU'] = create2context4jpu(task4create2context['JPU'])
            
            message2print = "{(Step J1/33) initialized" + "; jpu-initialized-by-create2context4xi to: " + str(context4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'J1-'
        except: 
            message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            context4xi['KPU'] = create2context4kpu(task4create2context['KPU'])
            
            message2print = "{(Step K1/33) initialized" + "; kpu-initialized-by-create2context4xi to: " + str(context4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'K1-'
        except: 
            message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            context4xi['LPU'] = create2context4lpu(task4create2context['LPU'])
            
            message2print = "{(Step L1/33) initialized" + "; lpu-initialized-by-create2context4xi to: " + str(context4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'L1-'
        except: 
            message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            context4xi['MPU'] = create2context4mpu(task4create2context['MPU'])
            
            message2print = "{(Step M1/33) initialized" + "; mpu-initialized-by-create2context4xi to: " + str(context4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'M1-'
        except: 
            message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            context4xi['NPU'] = create2context4npu(task4create2context['NPU'])
            
            message2print = "{(Step N1/33) initialized" + "; npu-initialized-by-create2context4xi to: " + str(context4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'N1-'
        except: 
            message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            context4xi['OPU'] = create2context4opu(task4create2context['OPU'])
            
            message2print = "{(Step O1/33) initialized" + "; opu-initialized-by-create2context4xi to: " + str(context4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'O1-'
        except: 
            message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            context4xi['PPU'] = create2context4ppu(task4create2context['PPU'])
            
            message2print = "{(Step P1/33) initialized" + "; ppu-initialized-by-create2context4xi to: " + str(context4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'P1-'
        except: 
            message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            context4xi['QPU'] = create2context4qpu(task4create2context['QPU'])
            
            message2print = "{(Step Q1/33) initialized" + "; qpu-initialized-by-create2context4xi to: " + str(context4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'Q1-'
        except: 
            message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            context4xi['RPU'] = create2context4rpu(task4create2context['RPU'])
            
            message2print = "{(Step R1/33) initialized" + "; rpu-initialized-by-create2context4xi to: " + str(context4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'R1-'
        except: 
            message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            context4xi['SPU'] = create2context4spu(task4create2context['SPU'])
            
            message2print = "{(Step S1/33) initialized" + "; spu-initialized-by-create2context4xi to: " + str(context4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'S1-'
        except: 
            message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            context4xi['TPU'] = create2context4tpu(task4create2context['TPU'])
            
            message2print = "{(Step T1/33) initialized" + "; tpu-initialized-by-create2context4xi to: " + str(context4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'T1-'
        except: 
            message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            context4xi['UPU'] = create2context4upu(task4create2context['UPU'])
            
            message2print = "{(Step U1/33) initialized" + "; upu-initialized-by-create2context4xi to: " + str(context4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'U1-'
        except: 
            message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            context4xi['VPU'] = create2context4vpu(task4create2context['VPU'])
            
            message2print = "{(Step V1/33) initialized" + "; vpu-initialized-by-create2context4xi to: " + str(context4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'V1-'
        except: 
            message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            context4xi['WPU'] = create2context4wpu(task4create2context['WPU'])
            
            message2print = "{(Step W1/33) initialized" + "; wpu-initialized-by-create2context4xi to: " + str(context4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'W1-'
        except: 
            message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            context4xi['XPU'] = create2context4xpu(task4create2context['XPU'])
            
            message2print = "{(Step X1/33) initialized" + "; xpu-initialized-by-create2context4xi to: " + str(context4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'X1-'
        except: 
            message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            context4xi['YPU'] = create2context4ypu(task4create2context['YPU'])
            
            message2print = "{(Step Y1/33) initialized" + "; ypu-initialized-by-create2context4xi to: " + str(context4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'Y1-'
        except: 
            message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ-'
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            context4xi['ZPU'] = create2context4zpu(task4create2context['ZPU'])
            
            message2print = "{(Step Z1/33) initialized" + "; zpu-initialized-by-create2context4xi to: " + str(context4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + 'Z1-'
        except: 
            message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ-'
                               

          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{(Step 33/33) returning" + "; context4xi-returning-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'VPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'DPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'RPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'SPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'APU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'PPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'GPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'CPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}
  

    return context4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2context4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF CONTEXT4XI5TEST - TRYING TO SET CONTEX4XI ', time4xi())
#     try:                               
#         response4set2context = set2context4xi()                                                       
#         print('(Step 4B/33) OF CONTEXT4XI5TEST - RESPONSE4SET2CONTEXT : ', response4set2context) 
#     except:
#         print('(Step 4Z1/33) OF CONTEXT4XI5TEST *** FAILED TO SET CONTEX4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def set2context4xi(task4set2context=None):

    '''
    sets context4xi
    '''
    global context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2context4xi"
    method2print = "set2context4xi"

    message2print = "{(Step 1A/33) started" + "; set2context4xi-started: " + str(set2context4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function set2context4xi at 0x0000000003612648>
  
             
    message2print = "{(Step 1B/33) passed" + "; task4set2context-to-set2context4xi: " + str(task4set2context) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'DPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'RPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'SPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'APU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'PPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'GPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'CPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
 
    code2ack  = ' '
    code2nack = ' '

    if context4xi is None:
        context4xi = create2context4xi()                                                                            # CREATE CONTEXT4XI
                                
        message2print = "{(Step 1C/33) set" + "; context4xi-set-by-set2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass 
           
       

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-set2context4apu: " + str(task4set2context['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        
        context4xi ['APU'] = set2context4apu(task4set2context['APU'])                                                     
         
        message2print = "{(Step A2/33) set" + "; apu-context-set-by-set2context4apu to: " + str(context4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'},
        #  'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}
  
        code2ack  = code2ack + 'A2-'
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-set2context4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-set2context4bpu: " + str(task4set2context['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['BPU'] = set2context4bpu(task4set2context['BPU'])                                                     
         
        message2print = "{(Step B2/33) set" + "; bpu-context-set-by-set2context4bpu to: " + str(context4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'B2-'
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-set2context4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-set2context4cpu: " + str(task4set2context['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['CPU'] = set2context4cpu(task4set2context['CPU'])                                                     
         
        message2print = "{(Step C2/33) set" + "; cpu-context-set-by-set2context4cpu to: " + str(context4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'C2-'
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-set2context4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-set2context4dpu: " + str(task4set2context['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['DPU'] = set2context4dpu(task4set2context['DPU'])                                                     
         
        message2print = "{(Step D2/33) set" + "; dpu-context-set-by-set2context4dpu to: " + str(context4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'D2-'
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-set2context4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-set2context4epu: " + str(task4set2context['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['EPU'] = set2context4epu(task4set2context['EPU'])                                                     
         
        message2print = "{(Step E2/33) set" + "; epu-context-set-by-set2context4epu to: " + str(context4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'E2-'
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-set2context4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-set2context4fpu: " + str(task4set2context['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['FPU'] = set2context4fpu(task4set2context['FPU'])                                                     
         
        message2print = "{(Step F2/33) set" + "; fpu-context-set-by-set2context4fpu to: " + str(context4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'F2-'
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-set2context4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-set2context4gpu: " + str(task4set2context['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['GPU'] = set2context4gpu(task4set2context['GPU'])                                                     
         
        message2print = "{(Step G2/33) set" + "; gpu-context-set-by-set2context4gpu to: " + str(context4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'G2-'
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-set2context4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-set2context4hpu: " + str(task4set2context['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['HPU'] = set2context4hpu(task4set2context['HPU'])                                                     
         
        message2print = "{(Step 2/33) set" + "; hpu-context-set-by-set2context4hpu to: " + str(context4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'H2-'
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-set2context4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-set2context4ipu: " + str(task4set2context['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['IPU'] = set2context4ipu(task4set2context['IPU'])                                                     
         
        message2print = "{(Step I2/33) set" + "; ipu-context-set-by-set2context4ipu to: " + str(context4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'I2-'
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-set2context4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-set2context4jpu: " + str(task4set2context['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['JPU'] = set2context4jpu(task4set2context['JPU'])                                                     
         
        message2print = "{(Step J2/33) set" + "; jpu-context-set-by-set2context4jpu to: " + str(context4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'J2-'
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-set2context4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-set2context4kpu: " + str(task4set2context['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['KPU'] = set2context4kpu(task4set2context['KPU'])                                                     
         
        message2print = "{(Step K2/33) set" + "; kpu-context-set-by-set2context4kpu to: " + str(context4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'K2-'
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-set2context4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-set2context4lpu: " + str(task4set2context['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['LPU'] = set2context4lpu(task4set2context['LPU'])                                                     
         
        message2print = "{(Step L2/33) set" + "; lpu-context-set-by-set2context4lpu to: " + str(context4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'L2-'
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-set2context4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-set2context4mpu: " + str(task4set2context['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['MPU'] = set2context4mpu(task4set2context['MPU'])                                                     
         
        message2print = "{(Step M2/33) set" + "; mpu-context-set-by-set2context4mpu to: " + str(context4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'M2-'
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-set2context4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-set2context4npu: " + str(task4set2context['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['NPU'] = set2context4npu(task4set2context['NPU'])                                                     
         
        message2print = "{(Step N2/33) set" + "; npu-context-set-by-set2context4npu to: " + str(context4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'N2-'
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-set2context4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-set2context4opu: " + str(task4set2context['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['OPU'] = set2context4opu(task4set2context['OPU'])                                                     
         
        message2print = "{(Step O2/33) set" + "; opu-context-set-by-set2context4opu to: " + str(context4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'O2-'
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-set2context4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-set2context4ppu: " + str(task4set2context['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['PPU'] = set2context4ppu(task4set2context['PPU'])                                                     
         
        message2print = "{(Step P2/33) set" + "; ppu-context-set-by-set2context4ppu to: " + str(context4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'P2-'
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-set2context4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-set2context4qpu: " + str(task4set2context['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['QPU'] = set2context4qpu(task4set2context['QPU'])                                                     
         
        message2print = "{(Step Q2/33) set" + "; qpu-context-set-by-set2context4qpu to: " + str(context4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'Q2-'
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-set2context4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-set2context4rpu: " + str(task4set2context['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['RPU'] = set2context4rpu(task4set2context['RPU'])                                                     
         
        message2print = "{(Step R2/33) set" + "; rpu-context-set-by-set2context4rpu to: " + str(context4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'R2-'
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-set2context4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-set2context4spu: " + str(task4set2context['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['SPU'] = set2context4spu(task4set2context['SPU'])                                                     
         
        message2print = "{(Step S2/33) set" + "; spu-context-set-by-set2context4spu to: " + str(context4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'S2-'
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-set2context4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-set2context4tpu: " + str(task4set2context['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['TPU'] = set2context4tpu(task4set2context['TPU'])                                                     
         
        message2print = "{(Step T2/33) set" + "; tpu-context-set-by-set2context4tpu to: " + str(context4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'T2-'
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-set2context4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-set2context4upu: " + str(task4set2context['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['UPU'] = set2context4upu(task4set2context['UPU'])                                                     
         
        message2print = "{(Step U2/33) set" + "; upu-context-set-by-set2context4upu to: " + str(context4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'U2-'
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-set2context4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-set2context4vpu: " + str(task4set2context['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['VPU'] = set2context4vpu(task4set2context['VPU'])                                                     
         
        message2print = "{(Step V2/33) set" + "; vpu-context-set-by-set2context4vpu to: " + str(context4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'V2-'
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-set2context4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-set2context4wpu: " + str(task4set2context['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['WPU'] = set2context4wpu(task4set2context['WPU'])                                                     
         
        message2print = "{(Step W2/33) set" + "; wpu-context-set-by-set2context4wpu to: " + str(context4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'W2-'
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-set2context4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-set2context4xpu: " + str(task4set2context['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['XPU'] = set2context4xpu(task4set2context['XPU'])                                                     
         
        message2print = "{(Step X2/33) set" + "; xpu-context-set-by-set2context4xpu to: " + str(context4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'X2-'
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-set2context4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-set2context4ypu: " + str(task4set2context['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['YPU'] = set2context4ypu(task4set2context['YPU'])                                                     
         
        message2print = "{(Step Y2/33) set" + "; ypu-context-set-by-set2context4ypu to: " + str(context4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'Y2-'
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-set2context4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'

        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-set2context4zpu: " + str(task4set2context['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['ZPU'] = set2context4zpu(task4set2context['ZPU'])                                                     
         
        message2print = "{(Step Z2/33) set" + "; zpu-context-set-by-set2context4zpu to: " + str(context4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + 'Z2-'
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-set2context4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'


                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; context4xi-returning-by-set2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'DPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'RPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'SPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'APU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'PPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'GPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'CPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
    return context4xi

            
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2context4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF CONTEXT4XI5TEST - TRYING TO SET CONTEX4XI ', time4xi())
#     try:                               
#         response4retain2context = retain2context4xi()                                                       
#         print('(Step 4B/33) OF CONTEXT4XI5TEST - RESPONSE4SET2CONTEXT : ', response4retain2context) 
#     except:
#         print('(Step 4Z1/33) OF CONTEXT4XI5TEST *** FAILED TO SET CONTEX4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def retain2context4xi(task4retain2context=None):

    '''
    retains context4xi
    '''
    global context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2context4xi"
    method2print = "retain2context4xi"

    message2print = "{(Step 1A/33) started" + "; retain2context4xi-started: " + str(retain2context4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function retain2context4xi at 0x00000000036126C8> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4retain2context-to-retain2context4xi: " + str(task4retain2context) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'COUNT2REFERENCE': 1}, 
    #  'DPU': {'COUNT2REFERENCE': 1}, 
    #  'RPU': {'COUNT2REFERENCE': 1}, 
    #  'SPU': {'COUNT2REFERENCE': 1}, 
    #  'APU': {'COUNT2REFERENCE': 1}, 
    #  'PPU': {'COUNT2REFERENCE': 1}, 
    #  'GPU': {'COUNT2REFERENCE': 1}, 
    #  'CPU': {'COUNT2REFERENCE': 1}
    #}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 

             
    code2ack  = ' '
    code2nack = ' '

    if context4xi is None:
        context4xi = create2context4xi()                                                                            # CREATE CONTEXT4XI
                                
        message2print = "{(Step 1C/33) retain" + "; context4xi-retain-by-retain2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        
    # {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-retain2context4apu: " + str(task4retain2context['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['APU'] = retain2context4apu(task4retain2context['APU'])                                                      # 
         
        message2print = "{(Step A2/33) retain" + "; apu-context-retain-by-retain2context4apu to: " + str(context4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'A2-'
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-retain2context4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'


    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-retain2context4bpu: " + str(task4retain2context['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['BPU'] = retain2context4bpu(task4retain2context['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) retain" + "; bpu-context-retain-by-retain2context4bpu to: " + str(context4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'B2-'
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-retain2context4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-retain2context4cpu: " + str(task4retain2context['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['CPU'] = retain2context4cpu(task4retain2context['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) retain" + "; cpu-context-retain-by-retain2context4cpu to: " + str(context4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'C2-'
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-retain2context4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-retain2context4dpu: " + str(task4retain2context['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['DPU'] = retain2context4dpu(task4retain2context['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) retain" + "; dpu-context-retain-by-retain2context4dpu to: " + str(context4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'D2-'
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-retain2context4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-retain2context4epu: " + str(task4retain2context['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['EPU'] = retain2context4epu(task4retain2context['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) retain" + "; epu-context-retain-by-retain2context4epu to: " + str(context4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'E2-'
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-retain2context4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-retain2context4fpu: " + str(task4retain2context['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['FPU'] = retain2context4fpu(task4retain2context['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) retain" + "; fpu-context-retain-by-retain2context4fpu to: " + str(context4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'F2-'
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-retain2context4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G1/33) passing" + "; task-passing-to-retain2context4gpu: " + str(task4retain2context['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['GPU'] = retain2context4gpu(task4retain2context['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) retain" + "; gpu-context-retain-by-retain2context4gpu to: " + str(context4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'G2-'
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-retain2context4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-retain2context4hpu: " + str(task4retain2context['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['HPU'] = retain2context4hpu(task4retain2context['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) retain" + "; hpu-context-retain-by-retain2context4hpu to: " + str(context4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'H2-'
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-retain2context4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-retain2context4ipu: " + str(task4retain2context['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['IPU'] = retain2context4ipu(task4retain2context['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) retain" + "; ipu-context-retain-by-retain2context4ipu to: " + str(context4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'I2-'
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-retain2context4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-retain2context4jpu: " + str(task4retain2context['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['JPU'] = retain2context4jpu(task4retain2context['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) retain" + "; jpu-context-retain-by-retain2context4jpu to: " + str(context4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'J2-'
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-retain2context4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-retain2context4kpu: " + str(task4retain2context['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['KPU'] = retain2context4kpu(task4retain2context['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) retain" + "; kpu-context-retain-by-retain2context4kpu to: " + str(context4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'K2-'
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-retain2context4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
       
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-retain2context4lpu: " + str(task4retain2context['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['LPU'] = retain2context4lpu(task4retain2context['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) retain" + "; lpu-context-retain-by-retain2context4lpu to: " + str(context4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'L2-'
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-retain2context4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-retain2context4mpu: " + str(task4retain2context['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['MPU'] = retain2context4mpu(task4retain2context['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) retain" + "; mpu-context-retain-by-retain2context4mpu to: " + str(context4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'M2-'
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-retain2context4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-retain2context4npu: " + str(task4retain2context['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['NPU'] = retain2context4npu(task4retain2context['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) retain" + "; npu-context-retain-by-retain2context4npu to: " + str(context4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'N2-'
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-retain2context4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-retain2context4opu: " + str(task4retain2context['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['OPU'] = retain2context4opu(task4retain2context['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) retain" + "; opu-context-retain-by-retain2context4opu to: " + str(context4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'O2-'
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-retain2context4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-retain2context4ppu: " + str(task4retain2context['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['PPU'] = retain2context4ppu(task4retain2context['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) retain" + "; ppu-context-retain-by-retain2context4ppu to: " + str(context4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'P2-'
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-retain2context4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-retain2context4pu: " + str(task4retain2context['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['QPU'] = retain2context4qpu(task4retain2context['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) retain" + "; qpu-context-retain-by-retain2context4qpu to: " + str(context4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'Q2-'
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-retain2context4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-retain2context4rpu: " + str(task4retain2context['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['RPU'] = retain2context4rpu(task4retain2context['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) retain" + "; rpu-context-retain-by-retain2context4rpu to: " + str(context4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'R2-'
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-retain2context4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-retain2context4spu: " + str(task4retain2context['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['SPU'] = retain2context4spu(task4retain2context['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) retain" + "; spu-context-retain-by-retain2context4spu to: " + str(context4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'S2-'
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-retain2context4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-retain2context4tpu: " + str(task4retain2context['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['TPU'] = retain2context4tpu(task4retain2context['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) retain" + "; tpu-context-retain-by-retain2context4tpu to: " + str(context4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'T2-'
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-retain2context4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-retain2context4upu: " + str(task4retain2context['PU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['UPU'] = retain2context4upu(task4retain2context['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) retain" + "; upu-context-retain-by-retain2context4upu to: " + str(context4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'U2-'
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-retain2context4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-retain2context4pu: " + str(task4retain2context['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['VPU'] = retain2context4vpu(task4retain2context['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) retain" + "; vpu-context-retain-by-retain2context4vpu to: " + str(context4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'V2-'
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-retain2context4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-retain2context4wpu: " + str(task4retain2context['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['WPU'] = retain2context4wpu(task4retain2context['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) retain" + "; wpu-context-retain-by-retain2context4wpu to: " + str(context4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'W2-'
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-retain2context4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-retain2context4xpu: " + str(task4retain2context['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['XPU'] = retain2context4xpu(task4retain2context['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) retain" + "; xpu-context-retain-by-retain2context4xpu to: " + str(context4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'X2-'
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-retain2context4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-retain2context4ypu: " + str(task4retain2context['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['YPU'] = retain2context4ypu(task4retain2context['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) retain" + "; ypu-context-retain-by-retain2context4ypu to: " + str(context4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'Y2-'
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-retain2context4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-retain2context4zpu: " + str(task4retain2context['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['ZPU'] = retain2context4zpu(task4retain2context['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) retain" + "; zpu-context-retain-by-retain2context4zpu to: " + str(context4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 

        code2ack  = code2ack + 'Z2-'
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-retain2context4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'
                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; context4xi-returning-by-retain2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'DPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'RPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'SPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'APU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'PPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'GPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'CPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
    
    return context4xi

#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2context4xi" usage = "
#
# Example 1:
#     print('(Step 4A/33) OF CONTEXT4XI5TEST - TRYING TO RELEASE CONTEX4XI ', time4xi())
#     try:                               
#         response4release2context = release2context4xi()                                                       
#         print('(Step 4B/33) OF CONTEXT4XI5TEST - RESPONSE4SET2CONTEXT : ', response4release2context) 
#     except:
#         print('(Step 4Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RELEASE CONTEX4XI ', time4xi())                  
#                            
#">

# -------------------------------------------------------------------------------------------------   
def release2context4xi(task4release2context=None):

    '''
    releases context4xi
    '''
    global context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2context4xi"
    method2print = "release2context4xi"

    message2print = "{(Step 1A/33) started" + "; release2context4xi-started: " + str(release2context4xi)  + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # <function release2context4xi at 0x0000000003416748>
  
             
    message2print = "{(Step 1B/33) passed" + "; task4release2context-to-release2context4xi: " + str(task4release2context) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # None

             
    code2ack  = ' '
    code2nack = ' '

    if context4xi is None:
        context4xi = create2context4xi()                                                                            # CREATE CONTEXT4XI
                                
        message2print = "{(Step 1C/33) release" + "; context4xi-release-by-release2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A1/33) passing" + "; task-passing-to-release2context4apu: " + str(task4release2context['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['APU'] = release2context4apu(task4release2context['APU'])                                                      # 
         
        message2print = "{(Step A2/33) release" + "; apu-context-release-by-release2context4apu to: " + str(context4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'A2-'
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release2context4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B1/33) passing" + "; task-passing-to-release2context4bpu: " + str(task4release2context['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['BPU'] = release2context4bpu(task4release2context['BPU'])                                                      # 
         
        message2print = "{(Step B2/33) release" + "; bpu-context-release-by-release2context4bpu to: " + str(context4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'B2-'
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release2context4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C1/33) passing" + "; task-passing-to-release2context4cpu: " + str(task4release2context['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['CPU'] = release2context4cpu(task4release2context['CPU'])                                                      # 
         
        message2print = "{(Step C2/33) release" + "; cpu-context-release-by-release2context4cpu to: " + str(context4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'C2-'
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release2context4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D1/33) passing" + "; task-passing-to-release2context4dpu: " + str(task4release2context['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['DPU'] = release2context4dpu(task4release2context['DPU'])                                                      # 
         
        message2print = "{(Step D2/33) release" + "; dpu-context-release-by-release2context4dpu to: " + str(context4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'D2-'
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release2context4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E1/33) passing" + "; task-passing-to-release2context4epu: " + str(task4release2context['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['EPU'] = release2context4epu(task4release2context['EPU'])                                                      # 
         
        message2print = "{(Step E2/33) release" + "; epu-context-release-by-release2context4epu to: " + str(context4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'E2-'
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release2context4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F1/33) passing" + "; task-passing-to-release2context4fpu: " + str(task4release2context['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['FPU'] = release2context4fpu(task4release2context['FPU'])                                                      # 
         
        message2print = "{(Step F2/33) release" + "; fpu-context-release-by-release2context4fpu to: " + str(context4xi ['FPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'F2-'
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release2context4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step 1/33) passing" + "; task-passing-to-release2context4gpu: " + str(task4release2context['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['GPU'] = release2context4gpu(task4release2context['GPU'])                                                      # 
         
        message2print = "{(Step G2/33) release" + "; gpu-context-release-by-release2context4gpu to: " + str(context4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'G2-'
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release2context4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H1/33) passing" + "; task-passing-to-release2context4hpu: " + str(task4release2context['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['HPU'] = release2context4hpu(task4release2context['HPU'])                                                      # 
         
        message2print = "{(Step H2/33) release" + "; hpu-context-release-by-release2context4hpu to: " + str(context4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'H2-'
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release2context4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I1/33) passing" + "; task-passing-to-release2context4ipu: " + str(task4release2context['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['PU'] = release2context4ipu(task4release2context['IPU'])                                                      # 
         
        message2print = "{(Step I2/33) release" + "; ipu-context-release-by-release2context4ipu to: " + str(context4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'I2-'
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release2context4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J1/33) passing" + "; task-passing-to-release2context4jpu: " + str(task4release2context['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['JPU'] = release2context4jpu(task4release2context['JPU'])                                                      # 
         
        message2print = "{(Step J2/33) release" + "; jpu-context-release-by-release2context4jpu to: " + str(context4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'J2-'
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release2context4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K1/33) passing" + "; task-passing-to-release2context4kpu: " + str(task4release2context['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['KPU'] = release2context4kpu(task4release2context['KPU'])                                                      # 
         
        message2print = "{(Step K2/33) release" + "; kpu-context-release-by-release2context4kpu to: " + str(context4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'K2-'
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release2context4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L1/33) passing" + "; task-passing-to-release2context4lpu: " + str(task4release2context['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['LPU'] = release2context4lpu(task4release2context['LPU'])                                                      # 
         
        message2print = "{(Step L2/33) release" + "; lpu-context-release-by-release2context4lpu to: " + str(context4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'L2-'
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release2context4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M1/33) passing" + "; task-passing-to-release2context4mpu: " + str(task4release2context['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['MPU'] = release2context4mpu(task4release2context['MPU'])                                                      # 
         
        message2print = "{(Step M2/33) release" + "; mpu-context-release-by-release2context4mpu to: " + str(context4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'M2-'
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release2context4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N1/33) passing" + "; task-passing-to-release2context4npu: " + str(task4release2context['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['NPU'] = release2context4npu(task4release2context['NPU'])                                                      # 
         
        message2print = "{(Step N2/33) release" + "; npu-context-release-by-release2context4npu to: " + str(context4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'N2-'
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release2context4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O1/33) passing" + "; task-passing-to-release2context4opu: " + str(task4release2context['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['OPU'] = release2context4opu(task4release2context['OPU'])                                                      # 
         
        message2print = "{(Step O2/33) release" + "; opu-context-release-by-release2context4opu to: " + str(context4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'O2-'
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release2context4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P1/33) passing" + "; task-passing-to-release2context4ppu: " + str(task4release2context['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['PPU'] = release2context4ppu(task4release2context['PPU'])                                                      # 
         
        message2print = "{(Step P2/33) release" + "; ppu-context-release-by-release2context4ppu to: " + str(context4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'P2-'
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release2context4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q1/33) passing" + "; task-passing-to-release2context4qpu: " + str(task4release2context['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['QPU'] = release2context4qpu(task4release2context['QPU'])                                                      # 
         
        message2print = "{(Step Q2/33) release" + "; qpu-context-release-by-release2context4qpu to: " + str(context4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Q2-'
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release2context4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R1/33) passing" + "; task-passing-to-release2context4rpu: " + str(task4release2context['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['RPU'] = release2context4rpu(task4release2context['RPU'])                                                      # 
         
        message2print = "{(Step R2/33) release" + "; rpu-context-release-by-release2context4rpu to: " + str(context4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'R2-'
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release2context4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S1/33) passing" + "; task-passing-to-release2context4spu: " + str(task4release2context['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['SPU'] = release2context4spu(task4release2context['SPU'])                                                      # 
         
        message2print = "{(Step S2/33) release" + "; spu-context-release-by-release2context4spu to: " + str(context4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'S2-'
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release2context4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T1/33) passing" + "; task-passing-to-release2context4tpu: " + str(task4release2context['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['TPU'] = release2context4tpu(task4release2context['TPU'])                                                      # 
         
        message2print = "{(Step T2/33) release" + "; tpu-context-release-by-release2context4tpu to: " + str(context4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'T2-'
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release2context4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U1/33) passing" + "; task-passing-to-release2context4upu: " + str(task4release2context['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['UPU'] = release2context4upu(task4release2context['UPU'])                                                      # 
         
        message2print = "{(Step U2/33) release" + "; upu-context-release-by-release2context4upu to: " + str(context4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'U2-'
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release2context4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V1/33) passing" + "; task-passing-to-release2context4vpu: " + str(task4release2context['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['VPU'] = release2context4vpu(task4release2context['VPU'])                                                      # 
         
        message2print = "{(Step V2/33) release" + "; vpu-context-release-by-release2context4vpu to: " + str(context4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'V2-'
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release2context4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W1/33) passing" + "; task-passing-to-release2context4wpu: " + str(task4release2context['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['WPU'] = release2context4wpu(task4release2context['WPU'])                                                      # 
         
        message2print = "{(Step W2/33) release" + "; wpu-context-release-by-release2context4wpu to: " + str(context4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'W2-'
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release2context4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X1/33) passing" + "; task-passing-to-release2context4xpu: " + str(task4release2context['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['XPU'] = release2context4xpu(task4release2context['XPU'])                                                      # 
         
        message2print = "{(Step X2/33) release" + "; xpu-context-release-by-release2context4xpu to: " + str(context4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'X2-'
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release2context4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y1/33) passing" + "; task-passing-to-release2context4ypu: " + str(task4release2context['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['YPU'] = release2context4ypu(task4release2context['YPU'])                                                      # 
         
        message2print = "{(Step Y2/33) release" + "; ypu-context-release-by-release2context4ypu to: " + str(context4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Y2-'
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release2context4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z1/33) passing" + "; task-passing-to-release2context4zpu: " + str(task4release2context['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        context4xi ['ZPU'] = release2context4zpu(task4release2context['ZPU'])                                                      # 
         
        message2print = "{(Step Z2/33) release" + "; zpu-context-release-by-release2context4zpu to: " + str(context4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
     
        code2ack  = code2ack + 'Z2-'
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release2context4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------

    
    message2print = "{(Step 33/33) returning" + "; context4xi-returning-by-release2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'VPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003580348>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'DPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x000000000336BD48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'RPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003509748>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'SPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003518548>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'APU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000033611C8>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'PPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x00000000034FC948>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'GPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000034EDB48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
    #  'CPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003361F48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 04:03:17 05/15/11 Pacific Daylight Time}

    
    return context4xi

            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2context4xi" usage = "
#
#    try:                               
#        response4get2context = get2context4xi()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2context4xi():

    '''
    gets context4xi
    '''
    
    global context4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2context4xi"
    method2print = "get2context4xi"

    message2print = "{(Step 1A/33) started" + "; get2context-started: " + str(get2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # <function get2context4xi at 0x0000000003269CC8>; time: 05:21:08 05/05/11 Pacific Daylight Time}
    
    context2xi = None
    try: 
        if context4xi is None:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            context2xi = create2context4xi()
        else:
            # -------------------------------------------------------------------------------------
            # USE           
            # -------------------------------------------------------------------------------------         
            context2xi = context4xi 
            message2print = "{(Step 1B/33) warned" + "; context2xi-warned-by-get2context: " + " ** " + str(context2xi)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
    except:
        try:
            # -------------------------------------------------------------------------------------
            # TRY TO CREATE           
            # -------------------------------------------------------------------------------------           
            context2xi = create2context4xi()
            message2print = "{(Step 1C/33) warned" + "; context2xi-warned-by-get2context: " + " ** " + str(context2xi)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
        except:
            # -------------------------------------------------------------------------------------
            # YIELD!        
            # -------------------------------------------------------------------------------------                      
            message2print = "{(Step 1Z/33) yielded" + "; context2xi-yielded-by-get2context: " + str(context2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            context2xi = None
            
    message2print = "{(Step 33/33) returning" + "; context2xi-returning-by-get2context: " + str(context2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #
    

    
    return context2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "Context4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for Context" usage = "OpenCL Context"
#>

# =================================================================================================
class Context4Xi(object): 
    ''' 
    Context4Xi offers  methods for Context
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2context = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2context',
    'get2context',
    'release2context',
    'retain2context',
    'set2context',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-Context4Xi" usage = "initializes Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2context = None):
        '''
        _init__ method initializes Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Context4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; create-of-Context4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 05:37:12 05/15/11 Pacific Daylight Time 

        message2print = "{(Step 1B/33) borning" + "; context2xi-of-Context4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # context2xi-of-Context4Xi-borning 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-context2xi-of-Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2context-sharing-by-context2xi-of-Context4Xi: " + str(Context4Xi.classvariable2context)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2context-passed-to-create-of-Context4Xi: " + str(task4create2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2context-passing-to-create2context4xi-by-create-of-Context4Xi: " + str(task4create2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
        
        context2xi = create2context4xi(task4create2context)
        
        message2print = "{(Step 2B/33) performed" + "; create2context4xi-performed-by-create-of-Context4Xi: " + str(create2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2context4xi at 0x000000000355D248>     
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; context2xi-of-Context4Xi-activated " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 05:37:12 05/15/11 Pacific Daylight Time
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-context2xi-of-Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>   
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2context-shared-by-context2xi-of-Context4Xi: " + str(Context4Xi.classvariable2context)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None              
       
        message2print = "{(Step 3D/33) returning" + "; create-of-Context4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 05:37:12 05/15/11 Pacific Daylight Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-Context4Xi" usage = "initializes objects of Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def create2context(self, task4create2context = None):
        '''
        create2context method creates context for Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)            
        # -----------------------------------------------------------------------------------------              
        class2print = "Context4Xi"
        method2print = "create2context"
                      
        message2print = "{(Step 1A/33) started" + "; create-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:37:12 05/15/11 Pacific Daylight Time
            
        message2print = "{(Step 1B/33) passed" + "; task4create2context-passed-to-create-of-Context4Xi: " + str(task4create2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                  
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2context-passing-to-create2context4xi-by-create-of-Context4Xi: " + str(task4create2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
  
        context2xi = create2context4xi(task4create2context)

        message2print = "{(Step 2B/33) performed" + "; create2context4xi-performed-by-create-of-Context4Xi: " + str(create2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; context2xi-returning-by-create2context-of-Context4Xi: " + str(context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x00000000034C0348>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'DPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x00000000032ABD48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'RPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003449748>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'SPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x000000000345A548>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'APU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032A11C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'PPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x000000000343C948>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'GPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x000000000342DB48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'CPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x00000000032A1F48>, 'ACK2RETURN': ' 2B3B4B5B6B7B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 05:37:12 05/15/11 Pacific Daylight Time}
 
                
        return context2xi
                                
                            
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2context-of-Context4Xi" usage = "sets objects of Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2context(self, task4set2context = None):
        '''
        set2context method sets objects of Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Context4Xi"
        method2print = "set2context"
                     
        message2print = "{(Step 1A/33) started" + "; set2context-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2context-passed-to-set2context-of-Context4Xi: " + str(task4set2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2context-passing-to-set2context4xi-by-set2context-of-Context4Xi: " + str(task4set2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        context2xi = set2context4xi(task4set2context)

        message2print = "{(Step 2B/33) performed" + "; set2context4xi-performed-by-set2context-of-Context4Xi: " + str(set2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; context2xi-returning-by-set2context-of-Context4Xi: " + str(context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x00000000034C0348>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'DPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x00000000032ABD48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'RPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003449748>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'SPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x000000000345A548>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'APU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032A11C8>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'PPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x000000000343C948>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'GPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x000000000342DB48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'CPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 05:37:12 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x00000000032A1F48>, 'ACK2RETURN': ' 2B3B4B5B6B7B8B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 05:37:12 05/15/11 Pacific Daylight Time}
 
                
        return context2xi

    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2context-of-Context4Xi" usage = "releases objects of Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def release2context(self, task4release2context = None):
        '''
        release2context method releases objects of Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Context4Xi"
        method2print = "release2context"
                     
        message2print = "{(Step 1A/33) started" + "; release2context-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2context-passed-to-release2context-of-Context4Xi: " + str(task4release2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2context-passing-to-release2context4xi-by-release2context-of-Context4Xi: " + str(task4release2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None   
                
  
        context2xi = release2context4xi(task4release2context)

        message2print = "{(Step 2B/33) performed" + "; release2context4xi-performed-by-release2context-of-Context4Xi: " + str(release2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; context2xi-returning-by-release2context-of-Context4Xi: " + str(context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003347348>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'DPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x00000000032E8D48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'RPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003310748>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'SPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003320548>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'APU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032BA1C8>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'PPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x0000000003302948>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'GPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000032F4B48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'CPU': {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x00000000032BAF48>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 06:06:47 05/15/11 Pacific Daylight Time}
 
                
        return context2xi                                
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2context-of-Context4Xi" usage = "retains objects of Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2context(self, task4retain2context = None):
        '''
        retain2context method retains objects of Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Context4Xi"
        method2print = "retain2context"
                     
        message2print = "{(Step 1A/33) started" + "; retain2context-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2context-passed-to-retain2context-of-Context4Xi: " + str(task4retain2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #                                                           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2context-passing-to-retain2context4xi-by-retain2context-of-Context4Xi: " + str(task4retain2context) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #   
                
  
        context2xi = retain2context4xi(task4retain2context)

        message2print = "{(Step 2B/33) performed" + "; retain2context4xi-performed-by-retain2context-of-Context4Xi: " + str(retain2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; context2xi-returning-by-retain2context-of-Context4Xi: " + str(context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'VPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4vpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4vpu', 'METHOD': 'get2context4xi4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003347348>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'DPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4dpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4dpu', 'METHOD': 'get2context4xi4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x00000000032E8D48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'RPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4rpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4rpu', 'METHOD': 'get2context4xi4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003310748>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'SPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4spu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4spu', 'METHOD': 'get2context4xi4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x0000000003320548>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'APU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4apu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4apu', 'METHOD': 'get2context4xi4apu'}, 'FUNCTION2CALLBACK': <function trace2context4apu at 0x00000000032BA1C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'PPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4ppu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4ppu', 'METHOD': 'get2context4xi4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x0000000003302948>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'GPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4gpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4gpu', 'METHOD': 'get2context4xi4gpu'}, 'FUNCTION2CALLBACK': <function trace2context4gpu at 0x00000000032F4B48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None},
        #  'CPU': {'COUNT2REFERENCE': 2, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4cpu-failed ; time: 06:06:47 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4cpu', 'METHOD': 'get2context4xi4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x00000000032BAF48>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 06:06:47 05/15/11 Pacific Daylight Time}
 
                
        return context2xi                                
        
                                    
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2context-of-Context4Xi" usage = "gets objects of Context4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def get2context(self):
        '''
        get2context method gets objects of Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Context4Xi"
        method2print = "get2context"
                     
        message2print = "{(Step 1A/33) started" + "; get2context-of-Context4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        context2xi = get2context4xi()
        
        message2print = "{(Step 2A/33) returning" + "; context2xi-returning-by-get2context-of-Context4Xi: " + str(context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
        
        
        return context2xi
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Context4Xi" usage = "senses Context4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Context4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Context4Xi-sensing-by-sense-of-Context4Xi: " + str(Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2context-of-Context4Xi'] = Context4Xi.classvariable2context
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Context4Xi-sensed-by-sense-of-Context4Xi: " + str(Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Context4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
        
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Context4Xi" usage = "reasons Context4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Context4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Context4Xi-reasoning-by-reason-of-Context4Xi: " + str(Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Context4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Context4Xi-reasoned-by-reason-of-Context4Xi: " + str(Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Context4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # 
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Context4Xi" usage = "aces Context4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Context4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Context4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Context4Xi-acing-by-ace-of-Context4Xi: " + str(Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-Context4Xi'] = time4xi()
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Context4Xi-aced-by-ace-of-Context4Xi: " + str(Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Context4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
        # 
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   get2context4xi5test.txt
#   sense-test-get2context4xi.xml
#   reason-test-get2context4xi.xml
#   ace-test-get2context4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of context4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
